#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern double          Filter    = 15;
double RS[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0, RS);
   TimeFrame = MathMax(TimeFrame,_Period);
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
void start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return;
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(MathMax(Bars-counted_bars,3*TimeFrame/_Period),Bars-1);
         double dFilter=Filter*_Point;

   for(int i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
      if      (iHigh(NULL,TimeFrame,y)<iHigh(NULL,TimeFrame,y+1) && iHigh(NULL,TimeFrame,y)<RS[i+1]-dFilter) RS[i]=iHigh(NULL,TimeFrame,y);
      else if (iLow(NULL,TimeFrame,y)>iLow(NULL,TimeFrame,y+1)   && iLow(NULL,TimeFrame,y) >RS[i+1]+dFilter) RS[i]=iLow(NULL,TimeFrame,y);
      else                                                                                                   RS[i]=RS[i+1];      
   }
}
